"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const MethodMemberDoc_1 = require("./MethodMemberDoc");
/**
 * This represents a getter or setter overload of an accessor property.
 * There will be a PropertyMemberDoc that contains these docs.
 */
class AccessorInfoDoc extends MethodMemberDoc_1.MethodMemberDoc {
    constructor(host, accessorType, propertyDoc, declaration) {
        super(host, propertyDoc.containerDoc, propertyDoc.symbol, declaration);
        this.accessorType = accessorType;
        this.propertyDoc = propertyDoc;
        this.docType = `${this.accessorType}-accessor-info`;
        this.name = `${this.propertyDoc.name}:${this.accessorType}`;
        this.id = `${this.propertyDoc.id}:${this.accessorType}`;
        this.aliases = this.propertyDoc.aliases.map(alias => `${alias}:${this.accessorType}`);
        this.anchor = this.name;
    }
}
exports.AccessorInfoDoc = AccessorInfoDoc;
//# sourceMappingURL=AccessorInfoDoc.js.map