"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ClassLikeExportDoc_1 = require("../api-doc-types/ClassLikeExportDoc");
/**
 * Interfaces are class-like but can also have multiple declarations that are merged together
 */
class InterfaceExportDoc extends ClassLikeExportDoc_1.ClassLikeExportDoc {
    constructor(host, moduleDoc, symbol, aliasSymbol) {
        super(host, moduleDoc, symbol, symbol.valueDeclaration || symbol.getDeclarations()[0], aliasSymbol);
        this.docType = 'interface';
        this.additionalDeclarations = [];
        if (symbol.members) {
            this.members = this.getMemberDocs(symbol.members, true);
        }
        this.additionalDeclarations = symbol.getDeclarations()
            .filter(declaration => declaration !== this.declaration);
    }
}
exports.InterfaceExportDoc = InterfaceExportDoc;
//# sourceMappingURL=InterfaceExportDoc.js.map