"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require(".");
const getAccessibility_1 = require("./getAccessibility");
const path = require('canonical-path');
describe('getAccessibility', () => {
    let parser;
    let basePath;
    beforeEach(() => {
        parser = new _1.TsParser(require('dgeni/lib/mocks/log')(false));
        basePath = path.resolve(__dirname, '../../mocks');
    });
    it('should return the accessibility of class members', () => {
        const parseInfo = parser.parse(['tsParser/getAccessibility.test.ts'], basePath);
        const module = parseInfo.moduleSymbols[0];
        const testClassMembers = module.exportArray[0].members;
        const xee = testClassMembers.get('xee');
        expect(getAccessibility_1.getAccessibility(xee.declarations[0])).toEqual('public');
        const yuu = testClassMembers.get('yuu');
        expect(getAccessibility_1.getAccessibility(yuu.declarations[0])).toEqual('public');
        const bar = testClassMembers.get('bar');
        expect(getAccessibility_1.getAccessibility(bar.declarations[0])).toEqual('protected');
        const foo = testClassMembers.get('foo');
        expect(getAccessibility_1.getAccessibility(foo.declarations[0])).toEqual('private');
    });
});
//# sourceMappingURL=getAccessibility.spec.js.map