"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require(".");
const getExportDocType_1 = require("./getExportDocType");
const path = require('canonical-path');
describe('getExportDocType', () => {
    let parser;
    let basePath;
    beforeEach(() => {
        parser = new _1.TsParser(require('dgeni/lib/mocks/log')(false));
        basePath = path.resolve(__dirname, '../../mocks');
    });
    it('should return the accessibility of class members', () => {
        const parseInfo = parser.parse(['tsParser/getExportDocType.test.ts'], basePath);
        const moduleExports = parseInfo.moduleSymbols[0].exportArray;
        expect(moduleExports.length).toEqual(7);
        const docTypes = moduleExports.map(e => getExportDocType_1.getExportDocType(e));
        expect(docTypes).toContain('interface');
        expect(docTypes).toContain('class');
        expect(docTypes).toContain('function');
        expect(docTypes).toContain('enum');
        expect(docTypes).toContain('let');
        expect(docTypes).toContain('const');
        expect(docTypes).toContain('type-alias');
    });
});
//# sourceMappingURL=getExportDocType.spec.js.map