"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require(".");
const getTypeParametersText_1 = require("./getTypeParametersText");
const path = require('canonical-path');
describe('getTypeParametersText', () => {
    let parser;
    let basePath;
    beforeEach(() => {
        parser = new _1.TsParser(require('dgeni/lib/mocks/log')(false));
        basePath = path.resolve(__dirname, '../../mocks');
    });
    it('should return text representation of types', () => {
        const parseInfo = parser.parse(['tsParser/getTypeParametersText.test.ts'], basePath);
        const moduleExports = parseInfo.moduleSymbols[0].exportArray;
        const testFunction = moduleExports[0].getDeclarations()[0];
        expect(getTypeParametersText_1.getTypeParametersText(testFunction)).toEqual('<T, U, V>');
        const testClass = moduleExports[1];
        expect(getTypeParametersText_1.getTypeParametersText(testClass.getDeclarations()[0])).toEqual('<T>');
        expect(getTypeParametersText_1.getTypeParametersText(testClass.members.get('method').getDeclarations()[0])).toEqual('<U>');
    });
});
//# sourceMappingURL=getTypeParametersText.spec.js.map