import { Declaration, Type, TypeChecker, TypeFormatFlags } from 'typescript';
/**
 * Host that will be used for TypeScript AST operations that should be configurable or shared
 * across multiple doc types.
 */
export declare class Host {
    /** Whether multiple leading comments for a TypeScript node should be concatenated. */
    concatMultipleLeadingComments: boolean;
    /** Flags that will be used to format a Type into a string representation. */
    typeFormatFlags: TypeFormatFlags;
    getContent(declaration: Declaration): string;
    typeToString(typeChecker: TypeChecker, type: Type): string;
}
